<?php

/* ============================================== */
/* http://adrian.gaudebert.fr/turing/
/*
/* Link : app/actions/get_rules.php
/* Author : Grégory Barbier, Adrian Gaudebert - adrian@gaudebert.fr
/* Creation date : 15/05/2009
/* Last modification : 15/05/2009
/*
/* Description : 
/* * Page de traitement des données envoyées par le formulaire de la page d'accueil
/* 
/* ============================================== */

// Si l'utilisateur a bien envoyé quelque chose via le formulaire
if (isSet($_POST['submit']))
{
    Atomik::needed('Rules');
    
    $res = array('result' => true, 'error' => "");
    
    // On valide les trois champs état initial, final et caractère blanc
    if ( empty($_POST['initial_state']) || empty($_POST['final_state']) || empty($_POST['white_space']) )
    {
        // Si un des champs est vide, on renvoie une erreur
        if (empty($_POST['initial_state']))
        {
            $res = array('result' => false, 'error' => 'Le champ "Etat initial" est vide');
        }
        else if (empty($_POST['final_state']))
        {
            $res = array('result' => false, 'error' => 'Le champ "Etat final" est vide');
        }
        else if (empty($_POST['white_space']))
        {
            $res = array('result' => false, 'error' => 'Le champ "Caractère blanc" est vide');
        }
    }
    else
    {
        $initialState = htmlentities($_POST['initial_state']);
        $finalState = htmlentities($_POST['final_state']);
        $whiteSpace = htmlentities($_POST['white_space']);
        
        // Nombre de lignes de règles
        $nbLines = intval($_POST['line_count']);
        
        $lines = array();
        $champs = array('current_state', 'current_input', 'next_state', 'next_input', 'next_direction');
        
        // On récupère toutes les valeurs entrées, et on vérifie qu'aucune n'est vide
        for ($i = 1; $i <= $nbLines; $i++)
        {
            $lines[$i] = array();
            foreach ($champs as $champ)
            {
                $entry = $champ . '_' . $i;
                if (empty($_POST[$entry]))
                {
                    $res = array('result' => false, 'error' => "Le champ " . $entry . " est vide");
                    break;
                }
                $lines[$i][$champ] = htmlentities($_POST[$entry]);
            }
            
            if (!$res['result'])
            {
                break;
            }
        }
    }
    
    // En cas d'erreur, on envoie l'erreur et on retourne à la page d'accueil
    if (!$res['result'])
    {
        $_SESSION['resValidation'] = $res;
        header('location: ' . Atomik::url(''));
    }
    // Sinon, on créé les règles, on les charge et on passe à la validation
    else
    {
        $rules = new Rules();
        $rules->LoadFromInput($lines, $initialState, $finalState, $whiteSpace);
        
        $_SESSION['rules'] = serialize($rules);
        
        header('location: ' . Atomik::url('validate'));
    }
}
else
{
    header('location: ' . Atomik::url(''));
}

?>
