<?php

/* ============================================== */
/* http://adrian.gaudebert.fr/turing/
/*
/* Link : app/actions/load_rules.php
/* Author : Grégory Barbier, Adrian Gaudebert - adrian@gaudebert.fr
/* Creation date : 15/05/2009
/* Last modification : 15/05/2009
/*
/* Description : 
/* * Page de traitement des données lorsqu'envoyées depuis un fichier
/* 
/* ============================================== */

Atomik::needed('Rules');

if (isSet($_POST['submit']))
{
    // En cas d'erreur de transfert du fichier
    if ($_FILES['rules_file']['error'] > 0)
    {
        $_SESSION['resValidation'] = array('result' => false, 'error' => 'Problème durant le transfert du fichier');
        header('Location: ' . Atomik::url(''));
    }
    else
    {
        $extensions = array('txt');
        $fileExtension = strtolower( substr( strrchr( $_FILES['rules_file']['name'], '.'), 1) );
        
        // Si l'extension est valide
        if (in_array($fileExtension, $extensions))
        {
            $rules = "";
            
            $directoryName = 'private/files/';
            $fileName = md5(uniqid(rand(), true)) . '.' . $fileExtension;
            
            // Si le transfert du fichier est réussi
            if (move_uploaded_file($_FILES['rules_file']['tmp_name'], $directoryName.$fileName))
            {
                if ($fileExtension == 'txt')
                {
                    $rules = loadTxt($directoryName.$fileName);
                }
                
                // Si on a pu charger les règles, on passe à la validation
                if ($rules != "")
                {
                    $_SESSION['rules'] = serialize($rules);
                    
                    header('location: ' . Atomik::url('validate'));
                }
                else
                {
                    $_SESSION['resValidation'] = array('result' => false, 'error' => 'Impossible de charger le contenu du fichier');
                    header('Location: ' . Atomik::url(''));
                }
            }
            else
            {
                $_SESSION['resValidation'] = array('result' => false, 'error' => 'Problème durant la copie du fichier');
                header('Location: ' . Atomik::url(''));
            }
        }
        else
        {
            $_SESSION['resValidation'] = array('result' => false, 'error' => 'L\'extension du fichier n\'est pas reconnue');
            header('Location: ' . Atomik::url(''));
        }
    }
}
else
{
    header('Location: ' . Atomik::url(''));
}

// Fonction de chargement d'un fichier .txt
function loadTxt($fileName)
{
    $file = fopen($fileName, "r");
    
    $initialState = trim(fgets($file));
    $finalState = trim(fgets($file));
    $whiteSpace = trim(fgets($file));
    
    $lines = array();
    $champs = array('current_state', 'current_input', 'next_state', 'next_input', 'next_direction');
    
    $i = 1;
    
    // On récupère toutes les lignes du fichier
    while ( ($line = fgets($file)) !== false)
    {
        $words = explode(" ", $line);
        
        $lines[$i] = array();
        $j = 0;
        foreach ($champs as $champ)
        {
            $lines[$i][$champ] = trim(htmlentities($words[$j]));
            $j++;
        }
        
        $i++;
    }
    
    fclose($file);
    
    // On charge les règles
    $rules = new Rules();
    $rules->LoadFromInput($lines, $initialState, $finalState, $whiteSpace);
    
    return $rules;
}

?>
