<?php

/* ============================================== */
/* http://adrian.gaudebert.fr/turing/
/*
/* Link : app/actions/save_rules.php
/* Author : Grégory Barbier, Adrian Gaudebert - adrian@gaudebert.fr
/* Creation date : 15/05/2009
/* Last modification : 15/05/2009
/*
/* Description : 
/* * Traitement de la sauvegarde des règles dans un fichier
/* 
/* ============================================== */

// Si les règles ne sont pas entrées, on ne doit pas pouvoir accéder à cette page
if (!isSet($_SESSION['rules']))
{
    header('location: ' . Atomik::url(''));
}
else
{
    Atomik::needed('Rules');

    // Récupération des règles
    $rules = unserialize($_SESSION['rules']);
    
    // Si l'utilisateur a bien spécifié un format de sauvegarde
    if (isSet($_POST['save_format']))
    {
        $saveFormat = $_POST['save_format'];
        $fileName = '';
        
        // On créé le fichier
        if ($saveFormat == 'txt')
        {
            $fileName = saveTxt($rules);
        }
        
        if ($fileName != '')
        {
            // On lance le téléchargement du fichier créé
            header('Location: public/get_file.php?filename=' . $fileName);
        }
        else
        {
            header('Location: ' . Atomik::url('turing'));
        }
    }
}

// Fonction de création du fichier de règles en .txt
function saveTxt($rules)
{
    $directoryName = "public/files/";
    $fileName = "rules_" . md5(uniqid(rand(), true)) . '.txt';
    
    $file = fopen($directoryName.$fileName, "a+");
    
    fputs($file, $rules->initialState . "\n");
    fputs($file, $rules->finalState . "\n");
    fputs($file, $rules->whiteSpace);
    
    foreach ($rules->rules as $rule)
    {
        fputs($file, "\n");
        fputs($file, $rule->currentState . ' ');
        fputs($file, $rule->currentInput . ' ');
        fputs($file, $rule->nextState . ' ');
        fputs($file, $rule->nextInput . ' ');
        fputs($file, $rule->nextDirection);
    }
    
    fclose($file);
    
    return $fileName;
}

?>
